
#include <stdio.h>
#include "cell.h"

extern void	Error();

#define WORD	unsigned short
#define LEN	1024
#define PV	(size_t)((Cell)(~0))

void	CM_RGB(path,map,R,G,B)
char	*path,*map;
WORD	*R,*G,*B;
{
	FILE	*file;
	size_t	pv,pv1,pv2;
	char	text[LEN],str[LEN],*s,*brl="bad range list.";
	int	r,g,b,c;

	if (path[0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(path,"r"))==NULL) {
		(void)fputs(path,stderr); Error(" : file not found.");
	    }

	for (pv=0; pv<=PV; pv++) map[pv]=0;

	while (fgets(text,LEN,file)!=NULL) {
	    switch(sscanf(text,"%s %d %d %d",str,&r,&g,&b)) {
		case EOF: goto Break;
		case 2: b=g=r; break;
		case 4: break;
		default: Error("bad color specification.");
	    }
	    if (r<0 || r>=256 ||
		g<0 || g>=256 ||
		b<0 || b>=256) Error("bad R, G and/or B value.");

	    r*=257;
	    g*=257;
	    b*=257; s=str;

#define GETC()	(*(s++))
#define STON(n)	for (n=0; c>='0' && c<='9'; c=GETC()) \
		    if ((n=n*10+c-'0')>PV) Error(brl)

	    do {
		while ((c=GETC())==',') ;

		if (c!='\0') {
		    if (c=='-') {
			pv1=0;
			if ((c=GETC())==',' || c=='\0')
			    pv2=PV;
			else {
			    STON(pv2);
			    if (c!=',' && c!='\0') Error(brl);
			}
		    }
		    else {
			STON(pv1);
			if (c==',' || c=='\0')
			    pv2=pv1;
			else if (c=='-')
			    if ((c=GETC())==',' || c=='\0')
				pv2=PV;
			    else {
				STON(pv2);
				if ((c!=',' && c!='\0') || pv2<pv1) Error(brl);
			    }
			else
			    Error(brl);
		    }
		    for (pv=pv1; pv<=pv2; pv++) {
			map[pv]=1; R[pv]=(WORD)r;
				   G[pv]=(WORD)g;
				   B[pv]=(WORD)b;
		    }
		}
	    } while (c==',');
	}
Break:;
	if (file!=stdin) (void)fclose(file);
}
