
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "csi.h"
#include "rif_cm.h"
#include "sif.h"
#include "sif_cm.h"

extern void	Error(),CM_RGB();

#define LEN	1024
#define WORD	unsigned short
#define PV	(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,map[PV+1],*desc,path[LEN];
	int	Nz,BPS,color,colors,z,Nx,Ny,y;
	WORD	R[PV+1],G[PV+1],B[PV+1];
	size_t	len;
	Cell	**cell;

	if (argc!=4 && argc!=5)
	    Error("usage : si_cm_rgb orgDir nameFile {CM_RGB} newDir");

	paths=CheckSliceImages(argv[1],argv[2],NULL,NULL,&Nz,&BPS);

	if (argc==5) {
	    CM_RGB(argv[3],map,R,G,B);
	    colors=1<<BPS;
	    for (color=0; color<colors; color++)
		if (!map[color]) Error("insufficient color specification.");
	}
	len=strlen(argv[1])+1;

	for (z=0; z<Nz; z++) {
	    ReadImageFile_CM(paths[z],&Nx,&Ny,&BPS,NULL,NULL,NULL,&cell,&desc);

	    (void)sprintf(path,"%s/%s",argv[argc-1],paths[z]+len);
	    if (argc==4)
		StoreImageFile(path,Nx,Ny,BPS,cell,desc);
	    else
		StoreImageFile_CM(path,Nx,Ny,BPS,R,G,B,cell,desc);

	    for (y=0; y<Ny; y++) free(cell[y]); free(cell);
	}
	return 0;
}
