
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "rif_rgb.h"
#include "csi.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,*desc,path[LEN];
	int	Nz,z,Nx,Ny,BPS,shift,y,x;
	size_t	len;
	Cell	**R,**G,**B;

	if (argc!=4) Error("usage : si_rgb orgDir nameFile newDir");

	paths=CheckSliceImages(argv[1],argv[2],NULL,NULL,&Nz,NULL);

	len=strlen(argv[1])+1;

	for (z=0; z<Nz; z++) {
	    ReadImageFile_RGB(paths[z],&Nx,&Ny,&BPS,&R,&G,&B,&desc);

	    if (BPS>8) {
		shift=BPS-8;
		for (y=0; y<Ny; y++)
		for (x=0; x<Nx; x++) {
		    R[y][x]>>=shift; G[y][x]>>=shift; B[y][x]>>=shift;
		}
		BPS=8;
	    }
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++)
		if (R[y][x]!=G[y][x] || R[y][x]!=B[y][x]) goto Break;

Break:;
	    (void)sprintf(path,"%s/%s",argv[3],paths[z]+len);
	    if (x==Nx && y==Ny)
		StoreImageFile(path,Nx,Ny,BPS,R,desc);
	    else
		StoreImageFile_RGB(path,Nx,Ny,BPS,R,G,B,desc);

	    for (y=0; y<Ny; y++) {
		free(R[y]); free(G[y]); free(B[y]);
	    }
	    free(R); free(G); free(B);
	}
	return 0;
}
