
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,X,Y,i,y,v,x,h,Nh=1,Nv=1,gray=1;
	Cell	**Z,**r,**g,**b,R0=255,*R1=(&R0),**R=(&R1),
				G0=255,*G1=(&G0),**G=(&G1),
				B0=255,*B1=(&B0),**B=(&B1);
	double	unit,d,Lx,Ly,Lz,base,step,hx,vy,Zx,Zy,ratio=1.0;

	if (argc!=7 && argc!=8 && argc!=10)
    Error("usage : sr_map value.tif unit lon lat ratio sr_map.tif\n"
	  "        sr_map value.tif unit R G B lon lat ratio sr_map.tif\n"
	  "        sr_map value.tif unit color.tif lon lat ratio sr_map.tif");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&Z,NULL);

	if ((X=Nx-1)<=0 || (Y=Ny-1)<=0) Error("too few pixels.");

	unit=atof(argv[2]);

	if (argc==8) {
	    ReadImageFile_RGB(argv[3],&Nh,&Nv,&i,&R,&G,&B,NULL);

	    ratio=255.0/(double)((1<<i)-1);
	}
	else if (argc==10)
	    if ((R0=(Cell)atoi(argv[3]))>=256 ||
		(G0=(Cell)atoi(argv[4]))>=256 ||
		(B0=(Cell)atoi(argv[5]))>=256) Error("bad R, G and/or B.");

	if ((r=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (g=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (b=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (*r=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL ||
	    (*g=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL ||
	    (*b=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL)
	    Error("memory allocation error.");

	hx=(double)Nh/(double)Nx; vy=(double)Nv/(double)Ny;

	d=atof(argv[argc-4])*M_PI/180.0; Lx=cos(d); Ly=sin(d);
	d=atof(argv[argc-3])*M_PI/180.0; Lz=sin(d); d=cos(d); Lx*=d; Ly*=d;

	base=ratio-(step=ratio*atof(argv[argc-2]));

	for (y=0; y<Ny; y++) {
	    if (y>0) {
		r[y]=r[y-1]+Nx; g[y]=g[y-1]+Nx; b[y]=b[y-1]+Nx;
	    }
	    v=(int)(vy*((double)y+0.5));
	    for (x=0; x<Nx; x++) {
		h=(int)(hx*((double)x+0.5));

		Zx=unit*((x==0)? (double)Z[y][1  ]-(double)Z[y][0  ]:
			 (x==X)? (double)Z[y][X  ]-(double)Z[y][X-1]:
				((double)Z[y][x+1]-(double)Z[y][x-1])/2.0);
		Zy=unit*((y==0)? (double)Z[1  ][x]-(double)Z[0  ][x]:
			 (y==Y)? (double)Z[Y  ][x]-(double)Z[Y-1][x]:
				((double)Z[y+1][x]-(double)Z[y-1][x])/2.0);

	ratio=((d=Lz-Ly*Zy-Lx*Zx)<=0.0)?base:base+step*d/sqrt(Zx*Zx+Zy*Zy+1.0);

		       i=  r[y][x]=(Cell)(ratio*(double)R[v][h]+0.5);
		gray&=(i==(g[y][x]=(Cell)(ratio*(double)G[v][h]+0.5)));
		gray&=(i==(b[y][x]=(Cell)(ratio*(double)B[v][h]+0.5)));
	    }
	}
	if (gray)
	    StoreImageFile(argv[argc-1],Nx,Ny,8,r,NULL);
	else
	    StoreImageFile_RGB(argv[argc-1],Nx,Ny,8,r,g,b,NULL);

	return 0;
}
