
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_cm.h"
#include "sif.h"
#include "sif_cm.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Nx,Ny,BPS,colors,color;
	unsigned short	*R,*G,*B;
	Cell		**cell;
	char		*desc;
	FILE		*file;

switch(argc) {
    case 2 :
	ReadImageFile_CM(argv[1],NULL,NULL,&BPS,&R,&G,&B,NULL,NULL);
	(void)printf("%d\n",colors=1<<BPS);
	for (color=0; color<colors; color++)
	    (void)printf("%hu\t%hu\t%hu\n",R[color],G[color],B[color]);

	break;
    case 3 :
	ReadImageFile_CM(argv[1],&Nx,&Ny,&BPS,NULL,NULL,NULL,&cell,&desc);
	StoreImageFile(argv[2],Nx,Ny,BPS,cell,desc);
	break;
    case 4 :
	ReadImageFile_CM(argv[1],&Nx,&Ny,&BPS,&R,&G,&B,&cell,&desc);
	if (argv[2][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[2],"r"))==NULL) {
		(void)fprintf(stderr,"%s : file not found.\n",argv[2]); exit(1);
	    }

	if (fscanf(file,"%d",&color)!=1 || color<(colors=1<<BPS)) {
	    (void)fputs("bad number of colors.\n",stderr); exit(1);
	}
	for (color=0; color<colors; color++)
	    if (fscanf(file,"%hu %hu %hu",R+color,G+color,B+color)!=3) {
		(void)fputs("color data read error.\n",stderr); exit(1);
	    }

	if (file!=stdin) (void)fclose(file);

	StoreImageFile_CM(argv[3],Nx,Ny,BPS,R,G,B,cell,desc);
	break;
    default :
	(void)fputs("usage : tcm TIFF\n"
		    "        tcm TIFF gray_TIFF\n"
		    "        tcm TIFF CM CM_TIFF\n",stderr); exit(1);
}
	return 0;
}
