
#include <stdio.h>
#include "cell.h"
#include "rif_cm.h"
#include "sif.h"
#include "sif_cm.h"

extern void	Error(),CM_RGB();

#define WORD	unsigned short
#define PV	(size_t)((Cell)(~0))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,colors,color;
	WORD	*r,*g,*b,R[PV+1],G[PV+1],B[PV+1];
	Cell	**cell;
	char	*desc,map[PV+1];

switch(argc) {
    case 2 :
	ReadImageFile_CM(argv[1],NULL,NULL,&BPS,&r,&g,&b,NULL,NULL);
	colors=1<<BPS;
	for (color=0; color<colors; color++)
	    (void)printf("%d\t%hu\t%hu\t%hu\n",
			 color,r[color]>>8,g[color]>>8,b[color]>>8);

	break;
    case 3 :
	ReadImageFile_CM(argv[1],&Nx,&Ny,&BPS,NULL,NULL,NULL,&cell,&desc);
	StoreImageFile(argv[2],Nx,Ny,BPS,cell,desc);
	break;
    case 4 :
	ReadImageFile_CM(argv[1],&Nx,&Ny,&BPS,NULL,NULL,NULL,&cell,&desc);
	CM_RGB(argv[2],map,R,G,B);
	colors=1<<BPS;
	for (color=0; color<colors; color++)
	    if (!map[color]) Error("insufficient color specification.");

	StoreImageFile_CM(argv[3],Nx,Ny,BPS,R,G,B,cell,desc);
	break;
    default :
	Error("usage : tcm_rgb TIFF\n"
	      "        tcm_rgb TIFF gray_TIFF\n"
	      "        tcm_rgb TIFF CM_RGB CM_TIFF");
}
	return 0;
}
